/****************************************************************
   @PRG_NAME: AT89C51xx-Flash
   @PRG_VERS: V00.01.00
   @PRG_AUTH: Rene Schube
   @PRG_LICS: GNU/GPL V3.x
   @PRG_DATE: 2011

   @FILE_NAME: func.c
 ****************************************************************/
#include "main.h"

int CalcRecord( 
      unsigned char  ucByteCnt, 
      unsigned int   uiLoadOff, 
      unsigned char  ucRecType, 
      char           cData[MAX_BYTECOUNT]
);

/*
   +--+----+--+------+--+
   |02|0000|05|00..00|xx|
   +--+----+--+------+--+
     ^    ^  ^    ^    ^
     |    |  |    |    |
     |    |  |    |    +--- : CheckSumme
     |    |  |    +-------- : DataByte [n]
     |    |  +------------- : RecordType 0x03 = Write
     |    |                              0x04 = Display
     |    |                              0x05 = Read
     |    |                              0x07 = Programm EEPROM
     |    +---------------- : LoadOffset
     +--------------------- : ByteCount Record Lenght
 */
 
// cData[0] = 0x05;
// cData[1] = 0x00;
// iRetVal = CalcRecord(0x02, 0x0000, 0x05, cData[1]);
// printf("Record 01 [%s]\n", cBuffer);

int CalcRecord( 
      unsigned char  ucByteCnt, 
      unsigned int   uiLoadOff, 
      unsigned char  ucRecType, 
      char           cData[MAX_BYTECOUNT] )
{
   unsigned int   uiChkSum;
   unsigned char  ucLoadOff_H;
   unsigned char  ucLoadOff_L;
   
   ucLoadOff_H = uiLoadOff >> 8;
   ucLoadOff_L = uiLoadOff;

   sprintf(cBufArray,"\0");

   if ( ucByteCnt == 1 ) // 1 Byte in cData[]
   {
      uiChkSum = ((ucByteCnt + ucLoadOff_H + ucLoadOff_L + ucRecType + cData[0]) ^0xFF) + 0x01;
      //uiChkSum = uiChkSum & 0xFF;
      sprintf(cBufArray, ":%.2X%.2X%.2X%.2X%.2X%.2X\0", 
               ((unsigned char)ucByteCnt & 0xFF),
               ((unsigned char)ucLoadOff_H & 0xFF),
               ((unsigned char)ucLoadOff_L & 0xFF),
               ((unsigned char)ucRecType & 0xFF),
               ((unsigned char)cData[0] & 0xFF),
               ((unsigned char)uiChkSum & 0xFF) 
              );
   }
   
   if ( ucByteCnt == 2 ) // 2 Byte in cData[]
   {
      uiChkSum = ((ucByteCnt + ucLoadOff_H + ucLoadOff_L + ucRecType + cData[0] + cData[1]) ^0xFF) + 0x01;
      //uiChkSum = uiChkSum & 0xFF;
      sprintf(cBufArray, ":%.2X%.2X%.2X%.2X%.2X%.2X%.2X\0", 
               ((unsigned char)ucByteCnt & 0xFF),
               ((unsigned char)ucLoadOff_H & 0xFF),
               ((unsigned char)ucLoadOff_L & 0xFF),
               ((unsigned char)ucRecType & 0xFF),
               ((unsigned char)cData[0] & 0xFF),
               ((unsigned char)cData[1] & 0xFF),
               ((unsigned char)uiChkSum & 0xFF) 
              );
   }
   
   if ( ucByteCnt == 3 ) // 3 Byte in cData[]
   {
      uiChkSum = ((ucByteCnt + ucLoadOff_H + ucLoadOff_L + ucRecType + cData[0] + cData[1] + cData[2]) ^0xFF) + 0x01;
      //uiChkSum = uiChkSum & 0xFF;
      sprintf(cBufArray, ":%.2X%.2X%.2X%.2X%.2X%.2X%.2X%.2X\0", 
               ((unsigned char)ucByteCnt & 0xFF),
               ((unsigned char)ucLoadOff_H & 0xFF),
               ((unsigned char)ucLoadOff_L & 0xFF),
               ((unsigned char)ucRecType & 0xFF),
               ((unsigned char)cData[0] & 0xFF),
               ((unsigned char)cData[1] & 0xFF),
               ((unsigned char)cData[2] & 0xFF),
               ((unsigned char)uiChkSum & 0xFF) 
              );
   }
   
   if ( ucByteCnt == 5 ) // 5 Byte in cData[]
   {
      uiChkSum = ((ucByteCnt + ucLoadOff_H + ucLoadOff_L + ucRecType + cData[0] + cData[1] + cData[2] + cData[3] + cData[4]) ^0xFF) + 0x01;
      //uiChkSum = uiChkSum & 0xFF;
      sprintf(cBufArray, ":%.2X%.2X%.2X%.2X%.2X%.2X%.2X%.2X%.2X%.2X\0", 
               ((unsigned char)ucByteCnt & 0xFF),
               ((unsigned char)ucLoadOff_H & 0xFF),
               ((unsigned char)ucLoadOff_L & 0xFF),
               ((unsigned char)ucRecType & 0xFF),
               ((unsigned char)cData[0] & 0xFF),
               ((unsigned char)cData[1] & 0xFF),
               ((unsigned char)cData[2] & 0xFF),
               ((unsigned char)cData[3] & 0xFF),
               ((unsigned char)cData[4] & 0xFF),
               ((unsigned char)uiChkSum & 0xFF) 
              );
   }
   
   return 0;
}
// EOF - End of File
// Do not type any code after this line
